# coding: utf-8

"""
    Cloud Application Security API

    Imperva provides customers and partners with the ability to manage accounts and sites via an API. For more information, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/bundle/cloud-application-security/page/api/api.htm\">Cloud Application Security API Reference</a>.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiError(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'status': 'str',
        'code': 'str',
        'message': 'str',
        'source': 'ApiErrorSource'
    }

    attribute_map = {
        'id': 'id',
        'status': 'status',
        'code': 'code',
        'message': 'message',
        'source': 'source'
    }

    def __init__(self, id=None, status=None, code=None, message=None, source=None):  # noqa: E501
        """ApiError - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._status = None
        self._code = None
        self._message = None
        self._source = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if status is not None:
            self.status = status
        if code is not None:
            self.code = code
        if message is not None:
            self.message = message
        if source is not None:
            self.source = source

    @property
    def id(self):
        """Gets the id of this ApiError.  # noqa: E501

        Globally unique error id.  # noqa: E501

        :return: The id of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ApiError.

        Globally unique error id.  # noqa: E501

        :param id: The id of this ApiError.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def status(self):
        """Gets the status of this ApiError.  # noqa: E501

        HTTP status code  # noqa: E501

        :return: The status of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ApiError.

        HTTP status code  # noqa: E501

        :param status: The status of this ApiError.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def code(self):
        """Gets the code of this ApiError.  # noqa: E501

        Error code  # noqa: E501

        :return: The code of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ApiError.

        Error code  # noqa: E501

        :param code: The code of this ApiError.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def message(self):
        """Gets the message of this ApiError.  # noqa: E501

        Detailed error message  # noqa: E501

        :return: The message of this ApiError.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ApiError.

        Detailed error message  # noqa: E501

        :param message: The message of this ApiError.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def source(self):
        """Gets the source of this ApiError.  # noqa: E501


        :return: The source of this ApiError.  # noqa: E501
        :rtype: ApiErrorSource
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this ApiError.


        :param source: The source of this ApiError.  # noqa: E501
        :type: ApiErrorSource
        """

        self._source = source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiError, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiError):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
