# coding: utf-8

"""
    Cloud Application Security API

    Imperva provides customers and partners with the ability to manage accounts and sites via an API. For more information, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/bundle/cloud-application-security/page/api/api.htm\">Cloud Application Security API Reference</a>.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiResultReport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'res': 'int',
        'res_message': 'str',
        'debug_info': 'list[dict(str, object)]',
        'format': 'str',
        'report': 'str'
    }

    attribute_map = {
        'res': 'res',
        'res_message': 'res_message',
        'debug_info': 'debug_info',
        'format': 'format',
        'report': 'report'
    }

    def __init__(self, res=None, res_message=None, debug_info=None, format=None, report=None):  # noqa: E501
        """ApiResultReport - a model defined in Swagger"""  # noqa: E501
        self._res = None
        self._res_message = None
        self._debug_info = None
        self._format = None
        self._report = None
        self.discriminator = None
        if res is not None:
            self.res = res
        if res_message is not None:
            self.res_message = res_message
        if debug_info is not None:
            self.debug_info = debug_info
        if format is not None:
            self.format = format
        if report is not None:
            self.report = report

    @property
    def res(self):
        """Gets the res of this ApiResultReport.  # noqa: E501

        res - contains specific error code  # noqa: E501

        :return: The res of this ApiResultReport.  # noqa: E501
        :rtype: int
        """
        return self._res

    @res.setter
    def res(self, res):
        """Sets the res of this ApiResultReport.

        res - contains specific error code  # noqa: E501

        :param res: The res of this ApiResultReport.  # noqa: E501
        :type: int
        """

        self._res = res

    @property
    def res_message(self):
        """Gets the res_message of this ApiResultReport.  # noqa: E501


        :return: The res_message of this ApiResultReport.  # noqa: E501
        :rtype: str
        """
        return self._res_message

    @res_message.setter
    def res_message(self, res_message):
        """Sets the res_message of this ApiResultReport.


        :param res_message: The res_message of this ApiResultReport.  # noqa: E501
        :type: str
        """

        self._res_message = res_message

    @property
    def debug_info(self):
        """Gets the debug_info of this ApiResultReport.  # noqa: E501


        :return: The debug_info of this ApiResultReport.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._debug_info

    @debug_info.setter
    def debug_info(self, debug_info):
        """Sets the debug_info of this ApiResultReport.


        :param debug_info: The debug_info of this ApiResultReport.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._debug_info = debug_info

    @property
    def format(self):
        """Gets the format of this ApiResultReport.  # noqa: E501


        :return: The format of this ApiResultReport.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this ApiResultReport.


        :param format: The format of this ApiResultReport.  # noqa: E501
        :type: str
        """
        allowed_values = ["html", "xml", "amf", "pdf", "flash", "json", "mail", "csv", "statistics", "syslog"]  # noqa: E501
        if format not in allowed_values:
            raise ValueError(
                "Invalid value for `format` ({0}), must be one of {1}"  # noqa: E501
                .format(format, allowed_values)
            )

        self._format = format

    @property
    def report(self):
        """Gets the report of this ApiResultReport.  # noqa: E501


        :return: The report of this ApiResultReport.  # noqa: E501
        :rtype: str
        """
        return self._report

    @report.setter
    def report(self, report):
        """Sets the report of this ApiResultReport.


        :param report: The report of this ApiResultReport.  # noqa: E501
        :type: str
        """

        self._report = report

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiResultReport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiResultReport):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
