# coding: utf-8

"""
    Cloud Application Security API

    Imperva provides customers and partners with the ability to manage accounts and sites via an API. For more information, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/bundle/cloud-application-security/page/api/api.htm\">Cloud Application Security API Reference</a>.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BotsConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'canceled_good_bots': 'list[BotConfiguration]',
        'bad_bots': 'list[BotConfiguration]'
    }

    attribute_map = {
        'canceled_good_bots': 'canceledGoodBots',
        'bad_bots': 'badBots'
    }

    def __init__(self, canceled_good_bots=None, bad_bots=None):  # noqa: E501
        """BotsConfiguration - a model defined in Swagger"""  # noqa: E501
        self._canceled_good_bots = None
        self._bad_bots = None
        self.discriminator = None
        if canceled_good_bots is not None:
            self.canceled_good_bots = canceled_good_bots
        if bad_bots is not None:
            self.bad_bots = bad_bots

    @property
    def canceled_good_bots(self):
        """Gets the canceled_good_bots of this BotsConfiguration.  # noqa: E501

        Bots that an account user has removed from the list of bots that Imperva allows to access your website by default.  # noqa: E501

        :return: The canceled_good_bots of this BotsConfiguration.  # noqa: E501
        :rtype: list[BotConfiguration]
        """
        return self._canceled_good_bots

    @canceled_good_bots.setter
    def canceled_good_bots(self, canceled_good_bots):
        """Sets the canceled_good_bots of this BotsConfiguration.

        Bots that an account user has removed from the list of bots that Imperva allows to access your website by default.  # noqa: E501

        :param canceled_good_bots: The canceled_good_bots of this BotsConfiguration.  # noqa: E501
        :type: list[BotConfiguration]
        """

        self._canceled_good_bots = canceled_good_bots

    @property
    def bad_bots(self):
        """Gets the bad_bots of this BotsConfiguration.  # noqa: E501

        Bots that an account user has added to the list of bots that Imperva blocks by default.  # noqa: E501

        :return: The bad_bots of this BotsConfiguration.  # noqa: E501
        :rtype: list[BotConfiguration]
        """
        return self._bad_bots

    @bad_bots.setter
    def bad_bots(self, bad_bots):
        """Sets the bad_bots of this BotsConfiguration.

        Bots that an account user has added to the list of bots that Imperva blocks by default.  # noqa: E501

        :param bad_bots: The bad_bots of this BotsConfiguration.  # noqa: E501
        :type: list[BotConfiguration]
        """

        self._bad_bots = bad_bots

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BotsConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BotsConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
