# coding: utf-8

"""
    Cloud Application Security API

    Imperva provides customers and partners with the ability to manage accounts and sites via an API. For more information, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/bundle/cloud-application-security/page/api/api.htm\">Cloud Application Security API Reference</a>.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class HtmlInjectionItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'url': 'str',
        'url_pattern': 'str',
        'location': 'str',
        'content': 'str'
    }

    attribute_map = {
        'url': 'url',
        'url_pattern': 'url_pattern',
        'location': 'location',
        'content': 'content'
    }

    def __init__(self, url=None, url_pattern=None, location=None, content=None):  # noqa: E501
        """HtmlInjectionItem - a model defined in Swagger"""  # noqa: E501
        self._url = None
        self._url_pattern = None
        self._location = None
        self._content = None
        self.discriminator = None
        if url is not None:
            self.url = url
        if url_pattern is not None:
            self.url_pattern = url_pattern
        if location is not None:
            self.location = location
        if content is not None:
            self.content = content

    @property
    def url(self):
        """Gets the url of this HtmlInjectionItem.  # noqa: E501


        :return: The url of this HtmlInjectionItem.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this HtmlInjectionItem.


        :param url: The url of this HtmlInjectionItem.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def url_pattern(self):
        """Gets the url_pattern of this HtmlInjectionItem.  # noqa: E501


        :return: The url_pattern of this HtmlInjectionItem.  # noqa: E501
        :rtype: str
        """
        return self._url_pattern

    @url_pattern.setter
    def url_pattern(self, url_pattern):
        """Sets the url_pattern of this HtmlInjectionItem.


        :param url_pattern: The url_pattern of this HtmlInjectionItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["EQUALS", "NOT_EQUALS", "NOT_CONTAINS", "PREFIX", "SUFFIX", "NOT_PREFIX", "NOT_SUFFIX", "CONTAINS"]  # noqa: E501
        if url_pattern not in allowed_values:
            raise ValueError(
                "Invalid value for `url_pattern` ({0}), must be one of {1}"  # noqa: E501
                .format(url_pattern, allowed_values)
            )

        self._url_pattern = url_pattern

    @property
    def location(self):
        """Gets the location of this HtmlInjectionItem.  # noqa: E501


        :return: The location of this HtmlInjectionItem.  # noqa: E501
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this HtmlInjectionItem.


        :param location: The location of this HtmlInjectionItem.  # noqa: E501
        :type: str
        """

        self._location = location

    @property
    def content(self):
        """Gets the content of this HtmlInjectionItem.  # noqa: E501


        :return: The content of this HtmlInjectionItem.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this HtmlInjectionItem.


        :param content: The content of this HtmlInjectionItem.  # noqa: E501
        :type: str
        """

        self._content = content

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HtmlInjectionItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HtmlInjectionItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
